// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once
#include "ISCW_FSoftObjectProperty.h"

#include <memory>
#include <string>

using std::shared_ptr;
using std::wstring;

namespace Sourcify
{
	class ISCW_UClass;
	class ISCW_FSoftClassProperty : public virtual ISCW_FSoftObjectProperty
	{
	public:
		virtual ~ISCW_FSoftClassProperty() = default;

		virtual shared_ptr<ISCW_FSoftClassProperty> ToFSoftClassPropertyPtr() = 0;
		virtual shared_ptr<const ISCW_FSoftClassProperty> ToFSoftClassPropertyPtr() const = 0;

		virtual shared_ptr<ISCW_UClass> GetMetaClass() const = 0;

	};

	using ISCW_FSoftClassPropertyConstPtr = shared_ptr<const ISCW_FSoftClassProperty>;
	using ISCW_FSoftClassPropertyPtr = shared_ptr<ISCW_FSoftClassProperty>;
} // namespace Sourcify